--- old/usr/src/uts/common/fs/zfs/zfs_ioctl.c	Fri Dec 21 21:52:02 2012
+++ new/usr/src/uts/common/fs/zfs/zfs_ioctl.c	Fri Dec 21 21:52:02 2012
@@ -477,7 +477,7 @@
 	if (error == 0) {
 		error = secpolicy_zfs(cr);
 		if (error)
-			error = dsl_deleg_access_impl(ds, perm, cr);
+			error = dsl_deleg_access_impl(ds, perm, cr, B_TRUE);
 	}
 
 	dsl_dataset_rele(ds, FTAG);
@@ -494,7 +494,7 @@
 	if (error == 0) {
 		error = secpolicy_zfs(cr);
 		if (error)
-			error = dsl_deleg_access_impl(ds, perm, cr);
+			error = dsl_deleg_access_impl(ds, perm, cr, B_TRUE);
 	}
 	return (error);
 }
@@ -616,12 +616,14 @@
 		break;
 
 	case ZFS_PROP_QUOTA:
+	case ZFS_PROP_FILESYSTEM_LIMIT:
+	case ZFS_PROP_SNAPSHOT_LIMIT:
 		if (!INGLOBALZONE(curproc)) {
 			uint64_t zoned;
 			char setpoint[MAXNAMELEN];
 			/*
 			 * Unprivileged users are allowed to modify the
-			 * quota on things *under* (ie. contained by)
+			 * limit on things *under* (ie. contained by)
 			 * the thing they own.
 			 */
 			if (dsl_prop_get_integer(dsname, "zoned", &zoned,
@@ -2383,6 +2385,14 @@
 	case ZFS_PROP_REFQUOTA:
 		err = dsl_dataset_set_quota(dsname, source, intval);
 		break;
+	case ZFS_PROP_FILESYSTEM_LIMIT:
+		err = dsl_dir_validate_fs_ss_limit(dsname, intval,
+		    ZFS_PROP_FILESYSTEM_LIMIT);
+		break;
+	case ZFS_PROP_SNAPSHOT_LIMIT:
+		err = dsl_dir_validate_fs_ss_limit(dsname, intval,
+		    ZFS_PROP_SNAPSHOT_LIMIT);
+		break;
 	case ZFS_PROP_RESERVATION:
 		err = dsl_dir_set_reservation(dsname, source, intval);
 		break;
